#!/bin/bash
#
# Compiz switch
#
# Data: 	20/09/2012 13:01:49
# Autore: 	Lorenzo Saibal Forti <saibal@lorenzone.it>
#
# Copyleft:	2010 - Tutti i diritti riservati
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#=====================================================================


# nome del windows manager da controllare
CWM_NAME="compiz"

# prendo l'ultimo processo attivo (quello con PID più alto)
PIDOF=`pidof $CWM_NAME`

# se esiste zenity lo uso per le notifiche
ZENITY_ERROR=0

which zenity > /dev/null;

if [ $? -gt "0" ]
then

	let ZENITY_ERROR++
fi

# se il processo esiste
if [ -n "$PIDOF" ]
then

	# controllo che il processo non sia zombie
	PID_STATUS=`ps ax | grep 'Z' | grep -v grep | grep $CWM_NAME`

	# se il controllo è vuoto allora il processo è attivo
	if [ -z "$PID_STATUS" ]
	then

		if [ "$ZENITY_ERROR" -eq "0" ]
		then
			echo "message:Metacity attivato" | zenity --notification --listen --window-icon="info"
		fi
		echo "metacity attivato"

	else

		if [ "$ZENITY_ERROR" -eq "0" ]
		then
			echo "message:Compiz è in stato zombie. Avvio di Metacity" | zenity --notification --listen --window-icon="info"
		fi
		echo "compiz zombie. avvio metacity"


	fi

	# attivo metacity
	export DISPLAY=:0.0 ; metacity --replace &

else

	if [ "$ZENITY_ERROR" -eq "0" ]
	then
		echo "message:Compiz attivato" | zenity --notification --listen --window-icon="info"
	fi
	echo "compiz attivato"

	# avvio compiz e riavvio nautilis
	export DISPLAY=:0.0 ; compiz --replace &

	sleep 3

	killall -9 nautilus

fi